--
--   komazou-mac (Application.applescript)  --- komazou for Macintosh
-- 
-- This program uploads pictures using Komazou to 
-- Photozou(http://photozou.jp), a picture Social Networking Service.
-- Photozou is a trademark of Unoh Inc.(http://www.unoh.net)
--
-- Copyright (c) 2005 naoki iimura <amatubu@users.sourceforge.jp>
--
--   This file is part of komazou-mac
--
--   komazou-mac is free software; you can redistribute it and/or modify
--   it under the terms of the GNU General Public License as published by
--   the Free Software Foundation; either version 2 of the License, or
--   (at your option) any later version.
--
--   komazou-mac is distributed in the hope that it will be useful,
--   but WITHOUT ANY WARRANTY; without even the implied warranty of
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--   GNU General Public License for more details.
--
--   You should have received a copy of the GNU General Public License
--   along with Komazou; if not, write to the Free Software
--   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
--
--   Modified by    naoki iimura <amatubu@users.sourceforge.jp>

-- properties
property mail_address : ""
property photozou_password : ""
property photo_title : "no name"
property album : ""
property first_idle : 1

on idle
	--
	if first_idle is 1 then
		set_preferences()
		set fiest_idle to 0
		quit
	end if
end idle

-- if launched nomally, change preferences
on set_preferences()
	register_default()
	read_default()
	
	set tmp to text returned of (display dialog "Mail Address :" default answer mail_address)
	if tmp is not "" then
		set mail_address to tmp
	else
		quit
	end if
	
	set tmp to text returned of (display dialog "Password :" default answer "")
	if tmp is not "" then
		set photozou_password to tmp
	else
		quit
	end if
	
	display dialog "Preferences saved." buttons {"OK"}
	
	write_default()
	
	quit
end set_preferences

on open names
	set first_idle to 0
	register_default()
	read_default()
	
	-- if Mail Address is not set, ask of it.
	if mail_address is "" then
		set tmp to text returned of (display dialog "Mail Address :" default answer "")
		if tmp is not "" then
			set mail_address to tmp
		else
			quit
		end if
	end if
	
	-- if Password is not set, ask of it.
	if photozou_password is "" then
		set tmp to text returned of (display dialog "Password :" default answer "")
		if tmp is not "" then
			set photozou_password to tmp
		else
			quit
		end if
	end if
	
	set thisFldr to resource path of main bundle as string -- get path to Resources folder
	set myScript to thisFldr & "/komazou.pl -m " & mail_address & " -p " & photozou_password
	set myLib to thisFldr & "/lib"
	
	repeat with thisObj in names
		set thisObjPath to POSIX path of thisObj -- convert path to POSIX path
		
		-- ask Title and Album of the photo
		set tmp to text returned of (display dialog ("Title of " & thisObjPath) default answer photo_title)
		set tmp2 to text returned of (display dialog ("Album of " & thisObjPath) default answer album)
		set album to tmp2
		
		if tmp is not "" then
			set photo_title to tmp
			set other_options to ""
			if album is not "" then
				set other_options to " -a " & album
			end if
			-- upload photo using komazou
			set kekka to do shell script "perl -I" & myLib & " " & myScript & " -t " & photo_title & other_options & " " & thisObjPath
			display dialog kekka buttons {"OK"}
		end if
	end repeat
	
	write_default()
	
	quit
end open

-- register default preferences
on register_default()
	tell user defaults
		make new default entry at end of default entries with properties {name:"Mail_Address", contents:mail_address}
		make new default entry at end of default entries with properties {name:"Password", contents:photozou_password}
		make new default entry at end of default entries with properties {name:"Photo_Title", contents:photo_title}
		register
	end tell
end register_default

-- read preferences
on read_default()
	tell user defaults
		set mail_address to contents of default entry "Mail_Address"
		set photozou_password to contents of default entry "Password"
		set photo_title to contents of default entry "Photo_Title"
	end tell
end read_default

-- write preferences
on write_default()
	tell user defaults
		set contents of default entry "Mail_Address" to mail_address
		set contents of default entry "Password" to photozou_password
		set contents of default entry "Photo_Title" to photo_title
	end tell
end write_default

